class Matrix{
  double elem[][];
  int xSize, ySize;

  Matrix(int y, int x){
    elem=new double[y][x];
    this.xSize=x;
    this.ySize=y;
    for (int j=0;j<ySize;j++) for (int i=0;i<xSize;i++) elem[j][i]=0;
  }

  Matrix add(Matrix b){
    Matrix ris=new Matrix(ySize,xSize);
    for (int j=0;j<ySize;j++){
      for (int i=0;i<xSize;i++){
        ris.elem[j][i]=this.elem[j][i]+b.elem[j][i];
      }
    }
    return ris;
  }

  Matrix mult(Matrix b){
    Matrix ris=new Matrix(ySize,b.xSize);
    for (int j=0;j<ris.ySize;j++){
      for (int i=0;i<ris.xSize;i++){
        ris.elem[j][i]=0;
        for (int k=0;k<xSize;k++){
          ris.elem[j][i]+=this.elem[j][k]*b.elem[k][i];
        }
      }
    }
    return ris;
  }

  protected Object clone(){
    Matrix ris=new Matrix(ySize,xSize);
    for (int j=0;j<ySize;j++){
      for (int i=0;i<xSize;i++){
       ris.elem[j][i]=this.elem[j][i];
      }
    }
    return ris;
  }

  Matrix pivot(int y, int x){
    Matrix ris=(Matrix)this.clone();
    double s=ris.elem[y][x];
    if ((s!=0)&&(s!=1)){
      for (int i=0;i<xSize;i++){
       ris.elem[y][i]/=s;
     }
    }
    for (int j=0;j<ySize;j++){
      if(j!=y){
        s=ris.elem[j][x];
        if (s!=0){
         for (int i=0;i<xSize;i++){
          ris.elem[j][i]-=s*ris.elem[y][i];
         }
        }
      }
    }
    return ris;
  }

  double[] solve(){
    double[] sol=new double[ySize];
    int [] base=new int[ySize];

    Matrix ris=(Matrix)this.clone();
    int i;
    for (int j=0;j<ySize;j++){
      for (i=0;(i<xSize)&&(ris.elem[j][i]==0);i++){}
      ris=ris.pivot(j,i);
      base[i]=j;
    }
    for (int j=0;j<ySize;j++) sol[j]=ris.elem[base[j]][xSize-1];
    return sol;
  }

  public String toString(){
    StringBuffer tmp=new StringBuffer("") ; String cr="\r\n";
    for (int j=0;j<ySize;j++){
      for (int i=0;i<xSize;i++){
        tmp.append(elem[j][i]).append(",");
      }
      tmp.append(cr);
    }
    return new String(tmp);
  }

}