
//Title:        Omography Applet
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Andrea
//Company:      ...
//Description:  Your description

//package omog;

import java.awt.*;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.applet.*;

public class OmographyApplet extends Applet implements MouseListener {
  OmographyPanels op=new OmographyPanels();

  Punto[] uv=new Punto[4];
  int uvsize=0;
  Punto[] xy=new Punto[4];
  int xysize=0;

  Matrix h=new Matrix(3,3);

  public void start()  {
    this.setLayout(null);
    this.setBackground(SystemColor.controlShadow);
    this.setSize(new Dimension(640, 480));
    op.p1.setBackground(new Color(146, 195, 177));
    op.p1.setBounds(new Rectangle(10, 10, 210, 210));
    this.add(op.p1, null);
    this.addMouseListener(this);
    op.s.giveMatrix(h);
    op.s.givePanel(this);
  }

  public void mouseClicked(MouseEvent e) {

    if (uvsize<4){
      uv[uvsize]=new Punto(e.getX(),e.getY());
      Graphics g=this.getGraphics();
      g.setColor(Color.red);
      g.fillOval((int)uv[uvsize].x-2,(int)uv[uvsize].y-2,4,4);
      uvsize++;
      System.out.println("uv["+(uvsize-1)+"]="+uv[uvsize-1]);
    }

    if (uvsize==4){
      Matrix a=new Matrix(8,9);
      Punto[] xy=new Punto[4];
      xy[0]=new Punto(0,1);
      xy[1]=new Punto(1,1);
      xy[2]=new Punto(1,0);
      xy[3]=new Punto(0,0);

      for (int j=0;j<4;j++){
        a.elem[2*j][0]=xy[j].x;
        a.elem[2*j][1]=xy[j].y;
        a.elem[2*j][2]=1;
        a.elem[2*j][6]=-xy[j].x*uv[j].x;
        a.elem[2*j][7]=-xy[j].y*uv[j].x;
        a.elem[2*j][8]=uv[j].x;

        a.elem[2*j+1][3]=xy[j].x;
        a.elem[2*j+1][4]=xy[j].y;
        a.elem[2*j+1][5]=1;
        a.elem[2*j+1][6]=-xy[j].x*uv[j].y;
        a.elem[2*j+1][7]=-xy[j].y*uv[j].y;
        a.elem[2*j+1][8]=uv[j].y;
      }

      System.out.println("(DEBUG) Matrix a:\r\n"+a);
      double s[]=a.solve();

      h.elem[0][0]=s[0];
      h.elem[0][1]=s[1];
      h.elem[0][2]=s[2];
      h.elem[1][0]=s[3];
      h.elem[1][1]=s[4];
      h.elem[1][2]=s[5];
      h.elem[2][0]=s[6];
      h.elem[2][1]=s[7];
      h.elem[2][2]=1;

      op.s.giveMatrix(h);
      op.s.givePanel(this);
      uvsize++;

      Graphics g=this.getGraphics();
      Graphics g2=op.p1.getGraphics();
      for (int j=0;j<=10;j++){
        Color nuovo=new Color(
          (int) (Math.random()*255.0),
          (int) (Math.random()*255.0),
          (int) (Math.random()*255.0)
        );
        g.setColor(nuovo);
        g2.setColor(nuovo);
        for (int i=0;i<=10;i++){
          Matrix p1=new Matrix(3,1);
          p1.elem[0][0]=i/10.0;
          p1.elem[1][0]=j/10.0;
          p1.elem[2][0]=1;
          Matrix p2=h.mult(p1);
          g.drawOval(
            (int)(p2.elem[0][0]/p2.elem[2][0]),
            (int)(p2.elem[1][0]/p2.elem[2][0]),
            1,1
          );
          g2.drawOval(i*op.p1.getSize().width/10,j*op.p1.getSize().height/10,1,1);
        }
      }

      System.out.println("(DEBUG) Matrix h:\r\n"+h);
    }
  }

  public void mousePressed(MouseEvent e) {
    //TODO: implement this java.awt.event.MouseListener method;
  }

  public void mouseReleased(MouseEvent e) {
    //TODO: implement this java.awt.event.MouseListener method;
  }

  public void mouseEntered(MouseEvent e) {
    //TODO: implement this java.awt.event.MouseListener method;
  }

  public void mouseExited(MouseEvent e) {
    //TODO: implement this java.awt.event.MouseListener method;
  }

}



